#import "GS1EPCRFIDSGTINData.h"
@implementation GS1EPCRFIDSGTINData
{
	GS1EPCRFIDFilter *filter;
    GS1EPCRFIDPartition *partition;
}

- (instancetype)initWithEpcData:(NSData *)epcData{
    self = [super initWithEpcData:epcData];
    if (self) {
    }
    return self;
}

- (BOOL)setHexEpcValue:(NSString *)hexEpcValue dataLength:(NSUInteger)dataLength{
    @try {
        switch (dataLength) {
            case 2:{
                NSString *hexFilterAndPatrtionValue = [hexEpcValue substringFromIndex:2];
                long long filterAndPatrtionValue = strtoull([hexFilterAndPatrtionValue UTF8String], 0, 16);
                long long filterValue = filterAndPatrtionValue >> 5;
                long long patrtionValue = (filterAndPatrtionValue >>2) & 0x07;
                filter = [[GS1EPCRFIDFilter alloc]initWithDecimalfilterValue:filterValue];
                partition = [[GS1EPCRFIDPartition alloc]initWithDecimalPartitionValueValue:patrtionValue];
                if (!filter || filter.decimalfilterValue == 999) {
                    @throw [[NSException alloc] initWithName:@"Rfid filter error" reason:@"Filter is nill" userInfo:nil];
                }else if (!partition || partition.decimalPartitionValue == 999){
                    @throw [[NSException alloc] initWithName:@"Rfid partition error" reason:@"Partition is nill" userInfo:nil];
                }
                self.filterValue = filter.decimalfilterValue;
                self.partitionValue = partition.decimalPartitionValue;
            }
                break;
            case 8:{
                NSString *hexCompyAndItemValue = [hexEpcValue substringWithRange:NSMakeRange(3, 12)];
                long long companyAndItemValue = strtoull([hexCompyAndItemValue UTF8String], 0, 16);
                companyAndItemValue = (companyAndItemValue >> 2) & 0xFFFFFFFFFFF;
                long long companyValue = companyAndItemValue >> partition.itemBits;
                long long itemValue = companyAndItemValue & (NSUInteger)((pow(2, partition.itemBits))-1);
                self.companyValue = [self getCompyOrItemFormatValueWithCompyOrItemValue:companyValue andCompyOrItemFormatLenght:partition.companyDigits];
                self.itemValue = [self getCompyOrItemFormatValueWithCompyOrItemValue:itemValue andCompyOrItemFormatLenght:partition.itemDigits];
                
            }
                break;
            default:{
                if (dataLength == self.dataBits/8) {
                    NSString *hexSerialValue = [hexEpcValue substringFromIndex:14];
                    [self getSerialValueWithSerialHexStr:hexSerialValue];
					EPCHeader *epcHeader;
					if ([[self header] isKindOfClass:[EPCHeader class]]) {
						epcHeader = [self header];
					}else{
						return NO;
					}
                    if ( epcHeader.hexHeaderValue && ![epcHeader.hexHeaderValue isEqualToString:@""] &&
                        _companyValue && ![_companyValue isEqualToString:@""] &&
                        _itemValue && ![_itemValue isEqualToString:@""] &&
                        _serialValue && ![_serialValue isEqualToString:@""] &&
                        _serialURIValue && ![_serialURIValue isEqualToString:@""]) {
                        NSString *epcPureURI = [NSString stringWithFormat:@"urn:epc:id:sgtin:%@.%@.%@",_companyValue,_itemValue,_serialURIValue];
                        NSString *epcTagURI = [NSString stringWithFormat:@"urn:epc:tag:sgtin-%lld:%lld.%@",epcHeader.encodingLength,_filterValue,epcPureURI];
                        
                        self.rfidProductCD = [self getRfidProductCDWtihCompanyValue:_companyValue itemValue:_itemValue];
                        if (!self.rfidProductCD || [self.rfidProductCD isEqualToString:@""]) {
                            @throw [[NSException alloc] initWithName:@"Rfid productCD error" reason:@"ProductCD is nill" userInfo:nil];
                        }
                        self.epcPureURI = epcPureURI;
                        self.epcTagURI = epcTagURI;
                        self.barcodeType = @"SGTIN";
                    }else{
                        @throw [[NSException alloc] initWithName:@"Rfid data error" reason:@"Lack the necessary information" userInfo:nil];
                    }
                }
            }
                break;
        }
        return YES;
    } @catch (NSException *exception) {
        [self initData];
        return NO;
    } @finally {
        
    }
}

- (void)getSerialValueWithSerialHexStr:(NSString *)hexSerialValue  {
    @try {
        long long serialvalue = strtoull([hexSerialValue UTF8String], 0, 16);
        if ([self sgtinType] == SGTINTypeSGTIN_96) {

            serialvalue = serialvalue & 0x3FFFFFFFFF;
            self.serialValue = [NSString stringWithFormat:@"%lld",serialvalue];
            self.serialURIValue = _serialValue;

        }else if ([self sgtinType] == SGTINTypeSGTIN_198){
            NSDictionary *uriFromDic = @{@"22":@"%22",@"25":@"%25",@"26":@"%26",@"2F":@"%2F",@"3C":@"%3C",@"3E":@"%3E",@"3F":@"%3F"};
            NSMutableString *serialUriFromatStr = [NSMutableString string];
            int a = 3;
            int b = 0;
            int c = 0;
            NSMutableString *serialStr = [NSMutableString string];
            for (int i = 0; i< 20; i++) {
                if (a == 0) {
                    b +=2;
                    c = 2;
                }else if (a == 1) {
                    b +=2;
                    c = 2;
                }else if (a == 2){
                    b +=1;
                    c = 3;
                }else if (a == 3){
                    if (i != 0) {
                        b +=2;
                    }
                    c = 3;
                }
                NSString *hexStr = [hexSerialValue substringWithRange:NSMakeRange(b, c)];
                long long decValue = strtoull([hexStr UTF8String], 0, 16);
                decValue = decValue >> a & 0X07F;
                if (a == 3) {
                    a =0;
                }else{
                    a ++;
                }
                [serialStr appendFormat:@"%c",(int)decValue];
                NSString *hexValue = [NSString stringWithFormat:@"%x",(int)decValue];
                
                NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF = %@",[hexValue uppercaseString]];
                
                NSArray *uriFormat = [uriFromDic.allKeys filteredArrayUsingPredicate:pred];
                if (uriFormat && [uriFormat count] > 0) {
                    NSString *formatStr = [uriFromDic objectForKey:[uriFormat lastObject]];
                    [serialUriFromatStr appendString:formatStr];
                }else{
                    [serialUriFromatStr appendFormat:@"%c",(int)decValue];
                }
            }
//            while ([serialStr hasPrefix:@"0"]) {
//                [serialStr deleteCharactersInRange:NSMakeRange(0, 1)];
//            }
//            while ([serialUriFromatStr hasPrefix:@"0"]) {
//                [serialUriFromatStr deleteCharactersInRange:NSMakeRange(0, 1)];
//            }
            if (serialStr.length > 20) {
                @throw [[NSException alloc] initWithName:@"Rfid serialStr error" reason:@"Rfid‘s serial is to long" userInfo:nil];
            }
            self.serialValue = serialStr;
            self.serialURIValue = serialUriFromatStr;
        }
    } @catch (NSException *exception) {
        self.serialValue = @"";
        self.serialURIValue = @"";
    } @finally {
        
    }
}

- (void)initData{
    [super initData];
    _filterValue = 0;
    _partitionValue = 0;
    _companyValue = @"";
    _itemValue = @"";;
    _serialValue = @"";
    _serialURIValue = @"";
}

- (NSString *)getCompyOrItemFormatValueWithCompyOrItemValue:(long long)compyOrItemValue andCompyOrItemFormatLenght:(long long)compyOrItemLenght{
    @try {
        NSMutableString *formatValue = [NSMutableString stringWithFormat:@"%lld",compyOrItemValue];
        if (formatValue.length < compyOrItemLenght) {
            long long length = compyOrItemLenght-formatValue.length;
            for (int i = 0; i < length; i ++ ) {
                [formatValue insertString:@"0" atIndex:0];
            }
        }else if (formatValue.length > compyOrItemLenght){
            return nil;
        }
        return formatValue;
    } @catch (NSException *exception) {
        return @"";
    } @finally {
        
    }
}
- (NSString *)getRfidProductCDWtihCompanyValue:(NSString *)companyValue itemValue:(NSString *)itemValue{
    @try {
        NSString *indiCator = [itemValue substringToIndex:1];
        NSString *itemRef = [itemValue substringFromIndex:1];
        NSMutableString *rfidProductCD = [NSMutableString stringWithFormat:@"%@%@%@",indiCator,companyValue,itemRef];
        NSString *checkDigit = [self getCheckDigitWith:rfidProductCD];
        if (checkDigit && ![checkDigit isEqualToString:@""]) {
            [rfidProductCD appendString:checkDigit];
            return rfidProductCD;
        }
        return @"";
    } @catch (NSException *exception) {
        return @"";
    } @finally {
        
    }
}
- (NSString *)getCheckDigitWith:(NSString *)checkCode{
    @try {
        if (checkCode.length != 13) {
            return nil;
        }
        NSUInteger oddSum = 0;
        NSUInteger evenSum = 0;
        for(int i =1; i <= [checkCode length]; i++)
        {
            NSString *eanItemNumber = [checkCode substringWithRange:NSMakeRange(i-1, 1)];
            if (i %2 == 0) {
                evenSum += [eanItemNumber integerValue];
            }else{
                oddSum += [eanItemNumber integerValue];
            }
        }
        NSUInteger textNumber = oddSum * 3 + evenSum;
        NSUInteger text = (10 - (textNumber %10)) %10;
        return [NSString stringWithFormat:@"%lu",(unsigned long)text];
    } @catch (NSException *exception) {
        return nil;
    } @finally {
        
    }
}
@end

@implementation GS1EPCRFIDFilter
- (instancetype)initWithDecimalfilterValue:(long long)decimalfilterValue{
    self = [super init];
    if (self) {
        self.decimalfilterValue = decimalfilterValue;
    }
    return self;
}
- (void)setDecimalfilterValue:(long long)decimalfilterValue{
    @try {
        NSDictionary *filterDic = @{@"0":@"All Others (see Section 10.1)"
                                    ,@"1":@"Point of Sale (POS) Trade Item"
                                    ,@"2":@"Full Case for Transport"
                                    ,@"3":@"Reserved (see Section 10.1)"
                                    ,@"4":@"Inner Pack Trade Item Grouping for Handling"
                                    ,@"5":@"Reserved (see Section 10.1)"
                                    ,@"6":@"Unit Load"
                                    ,@"7":@"Unit inside Trade Item or component inside a product not intended for individual sale"};
        NSString *type = [filterDic objectForKey:[NSString stringWithFormat:@"%lld",decimalfilterValue]];
        if (type && ![type isEqualToString:@""]) {
            _decimalfilterValue = decimalfilterValue;
            _filterType = type;
        }else{
            [self initData];
            return;
        }
    } @catch (NSException *exception) {
        [self initData];
        return;
    } @finally {
        
    }
}

- (void)initData{
    _decimalfilterValue = 999;
    _binaryfilterValue = @"";
    _filterType = @"";
}

@end

@implementation GS1EPCRFIDPartition
- (instancetype)initWithDecimalPartitionValueValue:(long long)decimalPartitionValue{
    self = [super init];
    if (self) {
        self.decimalPartitionValue = decimalPartitionValue;
    }
    return self;
}
- (void)setDecimalPartitionValue:(long long)decimalPartitionValue{
    @try {
        NSDictionary *partitionDic = @{@"0":@[@{@"Company":@[@"40",@"12"]},@{@"Item":@[@"4",@"1"]}]
                                       ,@"1":@[@{@"Company":@[@"37",@"11"]},@{@"Item":@[@"7",@"2"]}]
                                       ,@"2":@[@{@"Company":@[@"34",@"10"]},@{@"Item":@[@"10",@"3"]}]
                                       ,@"3":@[@{@"Company":@[@"30",@"9"]},@{@"Item":@[@"14",@"4"]}]
                                       ,@"4":@[@{@"Company":@[@"27",@"8"]},@{@"Item":@[@"17",@"5"]}]
                                       ,@"5":@[@{@"Company":@[@"24",@"7"]},@{@"Item":@[@"20",@"6"]}]
                                       ,@"6":@[@{@"Company":@[@"20",@"6"]},@{@"Item":@[@"24",@"7"]}]
                                       };
        NSArray *partitionListAry = [partitionDic objectForKey:[NSString stringWithFormat:@"%lld",decimalPartitionValue]];
        if (partitionListAry && [partitionListAry count] > 0) {
            NSArray *companyAry = [[partitionListAry objectAtIndex:0] objectForKey:@"Company"];
            NSArray *itemAry = [[partitionListAry lastObject] objectForKey:@"Item"];
            _companyBits = [[companyAry objectAtIndex:0] longLongValue];
            _companyDigits = [[companyAry lastObject] longLongValue];
            _itemBits = [[itemAry objectAtIndex:0] longLongValue];
            _itemDigits = [[itemAry lastObject] longLongValue];
        }
    } @catch (NSException *exception) {
        [self initData];
        return;
    } @finally {
        
    }
}
- (void)initData{
    _decimalPartitionValue = 999;
    _companyBits = 0;
    _companyDigits = 0;
    _itemBits = 0;
    _itemDigits = 0;
}
@end
