#import "BLESleepTimeViewController.h"
#import <AsReaderDockSDK/AsReaderDockSDK.h>
#import "Utils.h"
@interface BLESleepTimeViewController ()<UITextFieldDelegate, AsReaderDeviceDelegate>
{
    
}


@property(weak, nonatomic) IBOutlet UITextField *textFieldSleepTime;
@end

@implementation BLESleepTimeViewController

-(void) viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.title = @"Sleep Time";
    [AsReaderRFIDDevice sharedInstance].delegateDevice = self;
    [[AsReaderRFIDDevice sharedInstance] getSleepTimeForBLEDevice];
    
}
- (IBAction)btnSetSleepTime:(id)sender
{
    int time = [[_textFieldSleepTime text]intValue];
    [[AsReaderRFIDDevice sharedInstance] setSleepTimeForBLEDevice:time type:SaveType_Permanet];
}


- (IBAction)btnGetSleepTime:(id)sender
{
    [[AsReaderRFIDDevice sharedInstance] getSleepTimeForBLEDevice];
}


- (void)receivedSleepTime:(int)time isAck:(BOOL)isAck{
    dispatch_async(dispatch_get_main_queue(), ^{
        self->_textFieldSleepTime.text = [NSString stringWithFormat:@"%d",time];
        
        if(isAck){
            [Utils showAlert:@"" message:@"Sleep Time change completed" view:self];
        }
    });
}
@end
